(function($) {
    jQuery.fn.extend({
        html5_qrcode: function(qrcodeSuccess, qrcodeError, videoError) {
            return this.each(function() {
                var currentElem = $(this);

                // var height = currentElem.height();
                // var width = currentElem.width();
                var height = 500;
                var width = 600;

                var vidElem = $('<video width="' + width + 'px" height="' + height + 'px"></video>').appendTo(currentElem);
                var canvasElem = $('<canvas id="qr-canvas" width="' + (width - 2) + 'px" height="' + (height - 2) + 'px" style="display:none;"></canvas>').appendTo(currentElem);

                var video = vidElem[0];
                var canvas = canvasElem[0];
                var context = canvas.getContext('2d');
                var localMediaStream;
                var timeOutScan = 1000;
                var timeOutSuccessScan = 3000;

                var scan = function() {
                    if (localMediaStream) {
                        //context.drawImage(video, 0, 0, 307, 250);
                        context.drawImage(video, 0, 0, width, height);

                        try {
                            $.data(currentElem[0], "timeout", setTimeout(scan, timeOutSuccessScan));
                            qrcode.decode();
                        } catch (e) {
                            $.data(currentElem[0], "timeout", setTimeout(scan, timeOutScan));
                            qrcodeError(e, localMediaStream);
                        }

                      //  $.data(currentElem[0], "timeout", setTimeout(scan, timeOutScan));

                    } else {
                        $.data(currentElem[0], "timeout", setTimeout(scan, timeOutScan));
                    }
                };//end snapshot function

          

                var successCallback = function(stream) {
                    video.srcObject = stream;
                    localMediaStream = stream;
                    $.data(currentElem[0], "stream", stream);
                    video.play();
                    $.data(currentElem[0], "timeout", setTimeout(scan, timeOutSuccessScan));
                };

                // Call the getUserMedia method with our callback functions
                // if (navigator.mozGetUserMedia) {
                //     navigator.mozGetUserMedia({video: true, audio: false}, successCallback, function(error) {
                //         videoError(error, localMediaStream);
                //     });
                // }
                if (navigator.mediaDevices.getUserMedia) {
                    //for firefox Quantum
                    navigator.mediaDevices.getUserMedia({video: true, audio: false}).then(successCallback).catch(function(error) {
                        videoError(error, localMediaStream);
                    });
                } else {
                    console.log('Native web camera streaming (navigator.mediaDevices.getUserMedia) not supported in this browser.');
                    // Display a friendly "sorry" message to the user
                }

                qrcode.callback = function (result) {
                    qrcodeSuccess(result, localMediaStream);
                };
            }); // end of html5_qrcode
        },
        html5_qrcode_stop: function() {
            return this.each(function() {
                //stop the stream and cancel timeouts
                $(this).data('stream').getVideoTracks().forEach(function(videoTrack) {
                    videoTrack.stop();
                });

                clearTimeout($(this).data('timeout'));
            });
        }
    });
})(jQuery);
